---
title: CanvasRenderingContext2D.arcTo()
slug: Web/API/CanvasRenderingContext2D/arcTo
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.arcTo()</code></strong> method of the Canvas 2D API adds a circular arc to the current sub-path, using the given control points and radius. The arc is automatically connected to the path's latest point with a straight line, if necessary for the specified parameters.</p>

<p>This method is commonly used for making rounded corners.</p>

<div class="notecard note">
<p><strong>Note:</strong> Be aware that you may get unexpected results when using a relatively large radius: the arc's connecting line will go in whatever direction it must to meet the specified radius.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.arcTo(<em>x1</em>, <em>y1</em>, <em>x2</em>, <em>y2</em>, <em>radius</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x1</code></dt>
 <dd>The x-axis coordinate of the first control point.</dd>
 <dt><code>y1</code></dt>
 <dd>The y-axis coordinate of the first control point.</dd>
 <dt><code>x2</code></dt>
 <dd>The x-axis coordinate of the second control point.</dd>
 <dt><code>y2</code></dt>
 <dd>The y-axis coordinate of the second control point.</dd>
 <dt><code>radius</code></dt>
 <dd>The arc's radius. Must be non-negative.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="How_arcTo_works">How arcTo works</h3>

<p>One way to think about <code>arcTo()</code> is to imagine two straight segments: one from the starting point to a first control point, and another from there to a second control point. Without <code>arcTo()</code>, these two segments would form a sharp corner: <code>arcTo()</code> creates a circular arc that fits this corner and smooths is out. In other words, the arc is tangential to both segments.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[17]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Tangential lines
ctx.beginPath();
ctx.strokeStyle = 'gray';
ctx.moveTo(200, 20);
ctx.lineTo(200, 130);
ctx.lineTo(50, 20);
ctx.stroke();

// Arc
ctx.beginPath();
ctx.strokeStyle = 'black';
ctx.lineWidth = 5;
ctx.moveTo(200, 20);
ctx.arcTo(200,130, 50,20, 40);
ctx.stroke();

// Start point
ctx.beginPath();
ctx.fillStyle = 'blue';
ctx.arc(200, 20, 5, 0, 2 * Math.PI);
ctx.fill();

// Control points
ctx.beginPath();
ctx.fillStyle = 'red';
ctx.arc(200, 130, 5, 0, 2 * Math.PI); // Control point one
ctx.arc(50, 20, 5, 0, 2 * Math.PI);   // Control point two
ctx.fill();
</pre>

<h4 id="Result">Result</h4>

<p>In this example, the path created by <code>arcTo()</code> is <strong>thick and black</strong>. <span style="color: gray;">Tangent lines are gray</span>, <span style="color: red;">control points are red</span>, and the <span style="color: blue;">start point is blue</span>.</p>

<p>{{ EmbedLiveSample('How_arcTo_works', 315, 165) }}</p>

<h3 id="Creating_a_rounded_corner">Creating a rounded corner</h3>

<p>This example creates a rounded corner using <code>arcTo()</code>. This is one of the method's most common uses.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>The arc begins at the point specified by <code>moveTo()</code>: (230, 20). It is shaped to fit control points at (90, 130) and (20, 20), and has a radius of 50. The <code>lineTo()</code> method connects the arc to (20, 20) with a straight line. Note that the arc's second control point and the point specified by <code>lineTo()</code> are the same, which produces a totally smooth corner.</p>

<pre class="brush: js; highlight:[14]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
const p0 = { x: 230, y: 20  }
const p1 = { x: 90,  y: 130 }
const p2 = { x: 20,  y: 20  }

const labelPoint = function (p) {
  const offset = 15;
  ctx.fillText('(' + p.x + ',' + p.y + ')', p.x + offset, p.y + offset);
}

ctx.beginPath();
ctx.moveTo(p0.x, p0.y);
ctx.arcTo(p1.x, p1.y, p2.x, p2.y, 50);
ctx.lineTo(p2.x, p2.y);

labelPoint(p0);
labelPoint(p1);
labelPoint(p2);

ctx.stroke();
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Creating_a_rounded_corner', 315, 165) }}</p>

<h3 id="Result_of_a_large_radius">Result of a large radius</h3>

<p>If you use a relatively large radius, the arc may appear in a place you didn't expect. In this example, the arc's connecting line goes above, instead of below, the coordinate specified by <code>moveTo()</code>. This happens because the radius is too large for the arc to fit entirely below the starting point.</p>

<h4 id="HTML_3">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_3">JavaScript</h4>

<pre class="brush: js; highlight:[6]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.beginPath();
ctx.moveTo(180, 90);
ctx.arcTo(180,130, 110,130, 130);
ctx.lineTo(110, 130);
ctx.stroke();
</pre>

<h4 id="Result_3">Result</h4>

<p>{{ EmbedLiveSample('Result_of_a_large_radius', 315, 165) }}</p>

<h3 id="Live_demo">Live demo</h3>

<p>More sophisticated demo of the method. You can play around with range input to see how arc changes.</p>

<h4 id="HTML_4">HTML</h4>

<pre class="brush: html">&lt;div&gt;
  &lt;label for="radius"&gt;Radius: &lt;/label&gt;
  &lt;input name="radius"  type="range" id="radius" min=0 max=100 value=50&gt;
  &lt;label for="radius"  id="radius-output"&gt;50&lt;/label&gt;
&lt;/div&gt;
&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_4">JavaScript</h4>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const ctx    = canvas.getContext('2d');

const controlOut = document.getElementById('radius-output');
const control    = document.getElementById('radius');
      control.oninput = () =&gt; {
          controlOut.textContent = r = control.value;
      };

const mouse = { x: 0, y: 0 };

let   r  = 100; // Radius
const p0 = { x: 0, y: 50 };

const p1 = { x: 100, y: 100 };
const p2 = { x: 150, y: 50 };
const p3 = { x: 200, y: 100 };

const labelPoint = function (p, offset, i = 0){
    const {x, y} = offset;
    ctx.beginPath();
    ctx.arc(p.x, p.y, 2, 0, Math.PI * 2);
    ctx.fill();
    ctx.fillText(`${i}:(${p.x}, ${p.y})`, p.x + x, p.y + y);
}

const drawPoints = function (points){
  for (let i = 0; i &lt; points.length; i++) {
    var p = points[i];
    labelPoint(p, { x: 0, y: -20 } , i)
  }
}

// Draw arc
const drawArc = function ([p0, p1, p2], r) {
  ctx.beginPath();
  ctx.moveTo(p0.x, p0.y);
  ctx.arcTo(p1.x, p1.y, p2.x, p2.y, r);
  ctx.lineTo(p2.x, p2.y);
  ctx.stroke();
}

let t0 = 0;
let rr = 0; // the radius that changes over time
let a  = 0; // angle
let PI2 = Math.PI * 2;
const loop = function (t) {
  t0 = t / 1000;
  a  = t0 % PI2;
  rr = Math.abs(Math.cos(a) * r);

  ctx.clearRect(0, 0, canvas.width, canvas.height);

  drawArc([p1, p2, p3], rr);
  drawPoints([p1, p2, p3]);
  requestAnimationFrame(loop);
}

loop(0);</pre>

<h4 id="Result_4">Result</h4>

<div>{{EmbedLiveSample('Live_demo', 315, 200) }}</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-arcto", "CanvasRenderingContext2D.arcTo")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.arcTo")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
